--[[
Copyright (c) 2013-2014 Incremental IP Limited
Copyright (c) 2014 Kevin Martin

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]
local P=1048576 local function V(P)return P:match("^%s*(.-)%s*$")end local function H(P)return string.sub(P:gsub("\"\"","\""),1,-2)end local E={}E.__index=E local function y(P)return((P:lower()):gsub("[^%w%d]+"," ")):gsub("^ *(.-) *$","%1")end function E.new(V,P)local H={}for P,V in pairs(P)do local E local u if type(V)=="table"then u={transform=V.transform;default=V.default}if V.name then E={y(V.name)}elseif V.names then E=V.names for P,V in ipairs(E)do E[P]=y(V)end end else if type(V)=="function"then u={transform=V}else u={}if type(V)=="string"then E={y(V)}end end end if not E then E={(P:lower()):gsub("[^%w%d]+"," ")}end u.name=P for P,V in ipairs(E)do H[V:lower()]=u end end return setmetatable({name_map=H},E)end function E.read_header(V,P)local H={}local E={}local u for P,n in ipairs(P)do n=y(n)local O=V.name_map[n]if O then H[P]=O E[O.name]=true u=true end end if not u then return end local n={}for P,V in pairs(V.name_map)do if not E[V.name]then local H=n[V.name]if H then H[#H+1]=P else n[V.name]={P}end end end if next(n)then local P={}for V,H in pairs(n)do local E if#H==1 then E="\'"..(H[1].."\'")else E=H[1]for P=2,#H-1,1 do E=E..(", \'"..(H[P].."\'"))end E=E..(" or \'"..(H[#H].."\'"))end P[#P+1]="Couldn\'t find a column named "..E end error(table.concat(P,"\n"),0)end V.index_map=H return true end function E.transform(H,P,V)local E=H.index_map[V]if E then if E.transform then local V V,P=pcall(E.transform,P)if not V then error(("Error reading field \'%s\': %s"):format(E.name,P),0)end end return P or E.default,E.name end end local u={}u.__index=u function u.new(E,V,H)return setmetatable({file=V;buffer_block_size=H or P;buffer_start=0,buffer=""},u)end function u.truncate(V,P)P=P-V.buffer_start if P>V.buffer_block_size then local H=V.buffer_block_size*math.floor((P-1)/V.buffer_block_size)V.buffer=V.buffer:sub(H+1)V.buffer_start=V.buffer_start+H end end function u.find(H,P,V)while true do local E,y,u=H.buffer:find(P,V-H.buffer_start)if not E or y==#H.buffer then local P=H.file:read(H.buffer_block_size)if not P then if not E then return else return E+H.buffer_start,y+H.buffer_start,u end end H.buffer=H.buffer..P else return E+H.buffer_start,y+H.buffer_start,u end end end function u.extend(V,P)local H=(P-#V.buffer)-V.buffer_start if H>0 then local P=V.buffer_block_size*math.ceil(H/V.buffer_block_size)local E=V.file:read(P)if not E then return end V.buffer=V.buffer..E end end function u.sub(H,P,V)H:extend(V)V=V==-1 and V or V-H.buffer_start return H.buffer:sub(P-H.buffer_start,V)end function u.close(P)P.file:close()P.file=nil end local n={",";"\t","|"}local O={record_limit=8}local function j(P,V,H)O.separator=V local E,y=math.huge,0 local u,n=0,0 local j=coroutine.wrap(function()H(P,O)end)for P in j do E=math.min(E,#P)y=math.max(y,#P)n=n+(P[2]and 1 or 0)u=u+1 end if n/u>.75 then return y-E else return math.huge end end function guess_separator(P,V)local H,E="",math.huge for y,u in ipairs(n)do local n,O=pcall(function()return j(P,u,V)end)if n and O<E then H=u E=O end end return H end local s={{length=2;BOMS={["\254\255"]=true,["\255\254"]=true}};{length=3;BOMS={["\239\187\191"]=true}}}local function w(P)for V,H in ipairs(s)do local E=P(1,H.length)if H.BOMS[E]then return H.length end end return 0 end local function W(P,E)local y=1 local u if P.truncate then u=function(V)y=y+V P:truncate(y)end else u=function(P)y=y+P end end local function n(V,H)H=H==-1 and H or(H+y)-1 return P:sub((V+y)-1,H)end local function O(V,H)H=H or 1 local E,u,n=P:find(V,(H+y)-1)if not E then return end return(E-y)+1,(u-y)+1,n end u(w(n))local j="(["..((E.separator or guess_separator(P,W)).."\n\r])")local s=1 local r=1 local i,d,k,R=0,{},{}local a,f local v,z local F=0 local function N(P)error(("%s:%d:%d: %s"):format(E.filename,v,z,P),0)end while true do local P,w,W local M v=r z=(y-s)+1 if n(1,1)=="\""then u(1)local V=0 repeat local P,H,E=O("\"(\"?)",V+1)V=H until E~="\""if not V then N("unmatched quote")end M=H P,w,W=O(" *([^ ])",V+1)if W and not W:match(j)then N("unmatched quote")end else P,w,W=O(j,1)M=V end P=(P or 0)-1 local Q=n(1,P)Q=(Q:gsub("\r\n","\n")):gsub("\r","\n")for P in Q:gmatch("\n()")do r=r+1 s=P+y end Q=M(Q)if#Q>0 then R=true end i=i+1 local Z if E.column_map and f then local P P,Q,Z=pcall(E.column_map.transform,E.column_map,Q,i)if not P then N(Q)end elseif a then Z=a[i]else Z=i end if Z then d[Z]=Q k[Z]={line=v,column=z}end if not W or W=="\r"or W=="\n"then if E.column_map and not f then f=E.column_map:read_header(d)elseif E.header and not f then if R or i>1 then a=d f=true end else if R or i>1 then coroutine.yield(d,k)F=F+1 if E.record_limit and F>=E.record_limit then break end end end i,d,k,R=0,{},{}end if not w then break end if W=="\r"or W=="\n"then if W=="\r"and n(w+1,w+1)=="\n"then w=w+1 end r=r+1 s=y+w end u(w)end end local r={lines=function(P)return coroutine.wrap(function()W(P.buffer,P.parameters)end)end,close=function(P)if P.buffer.close then P.buffer:close()end end;name=function(P)return P.parameters.filename end}r.__index=r local function i(P,V)V=V or{}V.filename=V.filename or"<unknown>"V.column_map=V.columns and E:new(V.columns)if not P then P=u:new(io.stdin)elseif io.type(P)=="file"then P=u:new(P)end local H={buffer=P,parameters=V}return setmetatable(H,r)end local function d(P,V)local H,E=io.open(P,"r")if not H then return nil,E end V=V or{}V.filename=P return i(u:new(H),V)end local function k(P)local V={}V[#V+1]="<(String) "V[#V+1]=((P:gmatch("[^\n]+"))()or""):sub(1,15)if#V[#V]>14 then V[#V+1]="..."end V[#V+1]=" >"return table.concat(V)end local function R(P,V)V=V or{}V.filename=V.filename or k(P)V.buffer_size=V.buffer_size or#P return i(P,V)end return{open=d,openstring=R,use=i}
